package com.mkyong.user;

import org.apache.wicket.PageParameters;
import org.apache.wicket.markup.html.form.Form;
import org.apache.wicket.markup.html.form.PasswordTextField;
import org.apache.wicket.markup.html.form.validation.EqualPasswordInputValidator;
import org.apache.wicket.markup.html.panel.FeedbackPanel;
import org.apache.wicket.markup.html.WebPage;
import org.apache.wicket.model.Model;
import org.apache.wicket.validation.validator.PatternValidator;

public class UserPage extends WebPage {

	//1 digit, 1 lower, 1 upper, 1 symbol "@#$%", from 6 to 20
	private final String PASSWORD_PATTERN = "((?=.*\\d)(?=.*[a-z])(?=.*[A-Z])(?=.*[@#$%]).{6,20})";

	public UserPage(final PageParameters parameters) {

		add(new FeedbackPanel("feedback"));

		//create a password field
		final PasswordTextField password = new PasswordTextField("password",
				Model.of(""));
		//for properties file
		password.setLabel(Model.of("Password")); 

		final PasswordTextField cpassword = new PasswordTextField("cpassword",
				Model.of(""));
		cpassword.setLabel(Model.of("Confirm Password"));

		password.add(new PatternValidator(PASSWORD_PATTERN));

		Form<?> form = new Form<Void>("userForm") {
			@Override
			protected void onSubmit() {
				//get the entered password and pass to next page
				PageParameters pageParameters = new PageParameters();
				pageParameters.add("password", password.getModelObject());
				setResponsePage(SuccessPage.class, pageParameters);

			}
		};

		add(form);
		form.add(password);
		form.add(cpassword);
		form.add(new EqualPasswordInputValidator(password, cpassword));

	}
}
